import time, os, signal, sys

from Thump import Mp3, CoreApp, Messages
from Thump.Io import Logs, Queues

class Player(CoreApp.CoreApp):

  def __init__(self):
    self.errorLog = Logs.PlayerErrorLog()

    CoreApp.CoreApp.__init__(self)

    self.accessLog = Logs.PlayerAccessLog()

    self.queues["queue"] = Queues.PlayerToQueue()
    self.queues["decoder"] = None

  #

  def cmd_seek(self):
    self.errorLog.debug("Player: seek: running...")
    self.queues["decoder"].seek(self.msg.data)
    self.errorLog.debug("Player: seek: done")

  def cmd_stop(self):
    print 'sending done'
    self.queues["queue"].send(Messages.DoneMsg())

  def cmd_pause(self):
    self.queues["decoder"].pause()

  def cmd_play(self):
    song = self.msg.data
    
    print "song is ->", song

    self.errorLog.debug("Player: playSong: playing %s" % song)

    self.accessLog.access(song)

    try:
      self.queues["decoder"] = Mp3.Mp3(song)
      self.queues["decoder"].play()
    except IOError, err:
      self.errorLog.debug("Player: playSong: %s" % err)
      self.errorLog.error(err)

  def cmd_die(self):
    self.queues["decoder"] = None
    CoreApp.CoreApp.cmd_die(self)
    



class testq: # a little outdated now
  import readline, time
  msg,testcmd,second,count = dict(),"play /home/music/n-z/xenogears/xenogears - in a dark sleep.mp3",0,0
  def pop(self):
    if 1: return self.test()
    try:
      text = raw_input("thump > ").strip()
      if text == "test": text = self.testcmd
      s = text.find(" ")
      return {"command":(s!=-1 and text[:s] or text).strip(),"data":(s!=-1 and text[s:] or "").strip()}
    except EOFError:
      print; import sys; sys.exit(0)

  cmds = ({"command":"stop","data":""}, {"command":"pause","data":""},
          {"command":testcmd.split()[0], "data":testcmd[testcmd.find(" ")+1:]})
  def test(self):
    time.sleep(random.randrange(0, 1)/float(10)); tm = time.time()
    if not int(str(tm).split(".")[0]) == self.second:
      self.second, self.count = int(str(tm).split(".")[0]), 0
    self.count +=1; print self.count
    return random.choice(self.cmds)

  __len__ = lambda *a: 1



class fakelog:
  debug = error = warning = info = critical = access = lambda *a: None

if __name__ == "__main__":
  try:
    import random
    player = Player()
    #player.q = testq()
    #player.errorLog = player.accessLog = fakelog()
    player.mainloop()
  except KeyboardInterrupt:
    player.cmd_die()
    sys.exit()


