import time, os, signal, sys

from Thump import CoreApp, Playlist, Messages
from Thump.Io import Logs, Queues

class QueueManager(CoreApp.CoreApp):

  def __init__(self):
    self.errorLog = Logs.QueueErrorLog()

    CoreApp.CoreApp.__init__(self)

    self.queues["player"] = Queues.QueueToPlayer()
    self.queues["outside"] = Queues.QueueToOutside()

    self.playlist = Playlist.Playlist()

  # commands from outside

  # commands from player

  def cmd_done(self):
    print "player says it's done, sending another play command"
    msg = Messages.PlayMsg(self.playlist.get())
    self.queues["player"].send(msg)
    #self.queues["player"].send("play /home/music/n-z/xenogears/xenogears - in a dark sleep.mp3")
    print "done sending"


if __name__ == "__main__":
  try:
    q = QueueManager()
    q.mainloop()
  except KeyboardInterrupt:
    sys.exit()

