import time, sys

from Thump.Io import Logs
from Thump import Messages

DID_NOTHING = 0
DID_SOMETHING = 1

EXIT_MAIN_LOOP = 2

class CoreApp(object):

  granularity = 0.05

  queues = {}

  def __init__(self):
    if not self.errorLog:
      self.errorLog = Logs.NullLog()

    self.errorLog.debug("Hello world")

  def command(self):
    method = getattr(self, "cmd_" + self.msg.cmd)
    method()

  def validateCommand(self):
    print "coreapp: validateCommand"
    if hasattr(self, "cmd_" + self.msg.cmd):
      print "  valid"
      return True
    else:
      print "  invalid"
      self.errorLog.error("Unknown command: %s" % self.msg.cmd)

  def handleCommand(self):
    print 'coreapp: handleCommand: running command'
    if self.validateCommand():
      self.command()

  def flushQueues(self):
    didSomething = DID_NOTHING

    for q in self.queues.values():
      if not q:
        continue

      q.update()

      while 1:
        if not q.size():
          break

        self.msg = q.get()
        print "coreapp: flushQueues: got", self.msg
        self.handleCommand()
        didSomething = DID_SOMETHING

    return didSomething

  def mainloop(self):
    self.errorLog.debug("mainloop: running")
    while 1:
      ret = self.mainloopIter()
      
      assert ret in (DID_SOMETHING, DID_NOTHING)

      if ret is DID_NOTHING:
        time.sleep(self.granularity)

      elif ret is EXIT_MAIN_LOOP:
        return

  def mainloopIter(self):
    """Should return one of:  DID_NOTHING, DID_SOMETHING"""
    return self.flushQueues()
    # when overriding, return BREAK_MAIN_LOOP here to stop mainloop

  def cmd_die(self):
    self.errorLog.info("Exiting")
    sys.exit(0)
    self.errorLog.critical("How did I get here?")

