from os.path import exists

from Configuration import configFile

# base classes

class File(file):
  
  def __init__(self, filename, mode="rw"):
    if not exists(filename): open(filename, "w").close()
    file.__init__(self, filename, mode)

  def reOpen(self, mode=None):
    self.close()
    file.__init__(self, self.name, (mode and mode or self.mode))

  def niceWriteLines(self, lines):
    return self.writelines(map(lambda l: l.rstrip()+"\n", lines))

  def tail(self, numLines=1):
    return map(lambda l: l.rstrip(), lines)[-numLines:]


class NullFile(object):
  """A dummy file class that acts like a file, but does nothing."""

  mode = "rw"
  name = "/dev/null"
  closed = False
  softspace = False
  #encoding = ?

  close = fileno = flush = readinto = writelines = write = truncate = seek = \
    lambda *a, **b: None

  xreadlines = readline = read = lambda *a: str()

  isatty    = lambda: False
  tell      = lambda: int()
  readlines = lambda *a: list()

# thump-specific

class PidFile(File):
  def getPid(self):
    self.seek(0)
    line = self.readline.strip()
    return line.isdigit() and int(line) or 0

class PlayerPidFile(PidFile):
  def __init__(self, mode="rw"):
    PidFile.__init__(self, configFile.filenames["PlayerPid"], mode)

class QueuePidFile(PidFile):
  def __init__(self, mode="rw"):
    PidFile.__init__(self, configFile.filenames["QueuePid"], mode)

class StderrFile(File):
  def __init__(self, mode="w"):
    File.__init__(self, configFile.filenames["Stderr"], mode)


class PidFile(File):
  def getPid(self):
  


