import os, random, time
from Configuration import configFile

class Playlist(object):

  songs = []

  counter = 0

  name = ""

  todo = []

  toggles = {
    "shuffle": True,
    "repeat": True
  }

  def __init__(self):
    print time.time()
    self.updateToggles()
    self.loadDefaultList()
    print time.time()

  # file handling stuff

  def save(self):
    self._dumpListToFile(self.name)

  def saveas(self, name):
    self._dumpListToFile(name)

  def load(self, name):
    self.clear()

    self.setName(name)

    f = open(self._getFilePath(name), "r")

    map(self.songs.append, map(lambda l: l.strip(), f))

    f.close()

  def loadDefaultList(self):
    self.load("[default]")

  # list handling stuff

  def get(self):
    self.updateToggles()

    if self.toggles["shuffle"]:
      print 'shuffle is on'

      if not self.toggles["repeat"]:
        if counter >= len(self.songs):
          return False
        else:
          self.counter += 1

      return random.choice(self.songs)

    else: # no shuffle
      self.counter += 1

      if self.counter >= len(self.songs):
        if not self.toggles["repeat"]:
          return False
        else:
          self.counter = 1

      return self.songs[self.counter]


  def clear(self):
    self.songs = []

  # other / misc

  def setName(self, name):
    self.name = name

  # toggles

  def toggleShuffle(self):
    self.toggles["shuffle"] = not self.toggles["shuffle"]
    self.toggles["shuffle"] and self.shuffle() or self.unshuffle()

  def toggleRepeat(self):
    self.toggles["repeat"] = not self.toggles["repeat"]
    self.counter = 0

  def updateToggles(self):
    configFile.update()

    self.toggles.update(configFile.toggles)

  # handy stuff 

  def _dumpListToFile(self, name):
    name = self._nameToFilename(name)

    f = open(self._getFilePath(name), "w")

    map(f.write, [ song+"\n" for song in songs ])

    f.close()

  def _getFilePath(self, name):
    name = self._nameToFilename(name)

    return os.path.join(configFile.lists["listDir"], name)

  def _nameToFilename(self, name):
    configFile.update()

    if name == "[default]":
      name = configFile.lists["defaultList"]

    return name
