import xmlrpclib
from xml.parsers.expat import ExpatError

class XmlError(Exception):
  def __repr__(self):
    return 'Input was not valid XML'
  __str__ = __repr__

def dict2xml(mydict):
  try:
    return xmlrpclib.dumps((mydict,)).replace("\n", "")
  except ExpatError:
    return ""

def xml2dict(xmltext):
  try:
    return xmlrpclib.loads(xmltext)[0][0]
  except ExpatError:
    return {}

if __name__ == "__main__":
  try:
    obj = input()
    if isinstance(obj, dict):
      print dict2xml(obj)
    elif isinstance(obj, str):
      print xml2dict(obj)
    else:
      raise
  except:
    import sys
    print >> sys.stderr, "give me a dict, and i'll print out its xml "\
      "representation, or give me some xml, and i'll print it out as a dict"
    sys.exit(1)

